//
//  AppDelegate.m
//  nice2meet
//
//  Created by Netease on 15/7/30.
//  Copyright (c) 2015年 Netease. All rights reserved.
//

#import "AppDelegate.h"
#import "N2MSetting.h"
#import <avd_sdk/avd_sdk.h>

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd-HHmmss"];
    NSString *destDateString = [dateFormatter stringFromDate: [NSDate date] ];
    NSString *fileName =[NSString stringWithFormat:@"/%@.log", destDateString];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *docDir = [paths objectAtIndex:0];
    fileName = [docDir stringByAppendingPathComponent:fileName];
    //[[AVDEngine instance] setLogParams:@"verbose" file:fileName];
    //[[AVDEngine instance] initWithServerUrl: [N2MSetting getServerURL] accessKey: [N2MSetting getAppKey] secretKey:[N2MSetting getSecretKey] delegate:self];
//    AVDResult ret = [[AVDEngine instance] initWithServerUrl: @"webrtc.qiniuapi.com:80" OEM:@"qiniu.com" delegate:self];
//    if (AVD_Success == ret) {
//        [self onInitResult:ret];
//    }
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
}
- (void)applicationDidEnterBackground:(UIApplication *)application {
}
- (void)applicationWillEnterForeground:(UIApplication *)application {
}
- (void)applicationDidBecomeActive:(UIApplication *)application {
}

- (void)applicationWillTerminate:(UIApplication *)application {
    [[AVDEngine instance] uninit];
}

#pragma mark --avdengine delegate avd引擎回调
- (void)onInitResult:(AVDResult)result {
    if (AVD_Success == result) {
        [[UIApplication sharedApplication] setIdleTimerDisabled:YES];
        [[AVDEngine instance] setOption:video_codec_priority value:[N2MSetting getVideoCodecOption]];
        [[AVDEngine instance] setOption:camera_capability_default value:[N2MSetting getVideoResolutionOption]];
        [[AVDEngine instance] setOption:data_channel_tcp_priority value:[N2MSetting getDataChannelNetOption]];
        NSLog(@"AppDelegate, AVDEngine onInitResult init success");
    }
    else {
        NSLog(@"AppDelegate, AVDEngine onInitResult init failed. result:%lu",(unsigned long)result);
    }
}
- (void)onUninitResult:(AVDResult)reason {
    NSLog(@"AppDelegate, AVDEngine onUninitResult reason:%lu",(unsigned long)reason);
}

- (void) reInitEngine {
    if ([[AVDEngine instance] isWorking]) {
        [[AVDEngine instance] uninit];
    }
        [[AVDEngine instance] initWithServerUrl: [N2MSetting getServerURL] accessKey: [N2MSetting getAppKey] secretKey:[N2MSetting getSecretKey] delegate:self];
}

@end
