//
//  BaseRoomViewController.h
//  nice2meet
//
//  Created by skin on 16/3/18.
//  Copyright © 2016年 Netease. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "avd_sdk/AVDRoom.h"
#import "avd_sdk/AVDUserManager.h"
#import "avd_sdk/AVDAudio.h"
#import "avd_sdk/AVDVideo.h"
#import "ChatsView.h"
#import "UsersView.h"
#import "VideosView.h"
#import "T3RoomToolbar.h"

@interface BaseRoomViewController : UIViewController<AVDRoomDelegate>
@property (weak, nonatomic) IBOutlet ChatsView  *chats_ui;
@property (weak, nonatomic) IBOutlet UsersView  *users_ui;
@property (weak, nonatomic) IBOutlet VideosView *videos_ui;
@property (weak, nonatomic) IBOutlet T3RoomToolbar *toolbar;
//
@property (strong, nonatomic) AVDRoom *room;

- (void)leaveRoom;

#pragma mark --room delegate 房间回调
- (void)onJoinResult:(AVDResult)result;
- (void)onLeaveIndication:(AVDResult)reason fromUser:(AVDUserId)fromId;
- (void)onPublicData:(NSData*)data fromUser:(AVDUserId)fromId;
- (void)onPrivateData:(NSData*)data fromUser:(AVDUserId)fromId;
- (void)onAppDataNotify:(NSString*)key value:(NSString*)value;
- (void)onRoomStatusNotify:(enum AVDRoomStatus)status;
- (void)onConnectionStatus:(enum AVDConnectionStatus)status;

@end
