//
//  ChatContentCell.m
//  Created by Netease on 15/7/31.
//  Copyright (c) 2015年 Netease. All rights reserved.
//

#import "ChatContentCell.h"
#import "N2MSetting.h"

@interface ChatContentCell()
@property (nonatomic,strong) UIImageView *imgHead;
@property (nonatomic,strong) UIImageView *imgChatbg;

@end

@implementation ChatContentCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        [self setBackgroundColor:[UIColor grayColor]];
        self.imgHead = [[UIImageView alloc] initWithFrame:CGRectZero];
        self.imgChatbg = [[UIImageView alloc] initWithFrame:CGRectZero];
        self.userName = [[UILabel alloc] initWithFrame:CGRectZero];
        self.userName.backgroundColor = [UIColor clearColor];
        self.userName.lineBreakMode = NSLineBreakByWordWrapping;
        self.userName.font = [UIFont systemFontOfSize:14.0f];
        self.userName.textColor = [UIColor colorWithRed:0.21 green:0.21 blue:0.21 alpha:1.0];
        self.userName.lineBreakMode = NSLineBreakByTruncatingMiddle;
        self.message = [[UILabel alloc] initWithFrame:CGRectZero];
        self.message.backgroundColor = [UIColor clearColor];
        self.message.numberOfLines = 0;
        self.message.lineBreakMode = NSLineBreakByCharWrapping;
        self.message.font = [UIFont systemFontOfSize:18.0f];
        [self.contentView addSubview:self.imgHead];
        [self.imgChatbg addSubview:self.userName];
        [self.imgChatbg addSubview:self.message];
        [self.contentView addSubview:self.imgChatbg];
    }
    return self;
}

#define KSenderTextMaxWidth             95.f
#define KPaddingRL                      15.0f
#define KPaddingTop                     5.0f
#define kHeadWidth                      40.0f
#define KPaddingHead2Message            10.0f
#define KMessage_PaddingTop             12.f
#define KMessage_PaddingBottom          14.f
#define KMessage_PaddingBig             20.0f
#define KMessage_PaddingSmall           10.f
#define KCell_Span                      5.0f
- (void)showChatWithName:(NSString *)name userId:(NSString *)userId message:(NSString *)message isMe:(BOOL)isMe{
    if (nil == userId || nil == message) {
        return ;
    }
    NSLog(@"showChatWithName frame:%@",NSStringFromCGRect(self.frame));
    self.userName.hidden = isMe;
    self.userName.text = name;
    self.message.text = message;
    
    UIImage *head = [UIImage imageNamed:(isMe ? @"icon_head_me" : @"icon_head_he")];
    self.imgHead.image = [head stretchableImageWithLeftCapWidth:kHeadWidth topCapHeight:kHeadWidth];
    UIImage *chatbg = [UIImage imageNamed:(isMe ? @"bg_chat_me" : @"bg_chat_he")];
    self.imgChatbg.image = [chatbg stretchableImageWithLeftCapWidth:30 topCapHeight:kHeadWidth];
    CGFloat widthUsed = KPaddingRL + kHeadWidth;
    CGFloat X = isMe ? KPaddingRL : (self.availableWidth-widthUsed);
    widthUsed = KPaddingRL + kHeadWidth + KPaddingHead2Message;
    //
    CGSize szCell = [self getCellSize:message];
    X = isMe ? (X+KPaddingHead2Message+kHeadWidth) : (X-KPaddingHead2Message-szCell.width);
    self.imgChatbg.frame = CGRectMake(X,0,szCell.width,szCell.height);

    X = isMe ? KPaddingRL : (self.availableWidth-KPaddingRL-kHeadWidth);
    self.imgHead.frame = CGRectMake(X,(szCell.height-kHeadWidth),kHeadWidth,kHeadWidth);
    
    X = isMe ? KMessage_PaddingBig : KMessage_PaddingSmall;
    szCell.width -= (KMessage_PaddingSmall+KMessage_PaddingBig);
    szCell.height -= (KMessage_PaddingTop+KMessage_PaddingBottom+KCell_Span);
    self.message.frame = CGRectMake(X,KMessage_PaddingTop,szCell.width,szCell.height);
}

- (CGSize)getMessageSize:(NSString *)message {
    self.message.text = message;
    CGFloat messageAvailableWidth = self.availableWidth-(KPaddingRL+kHeadWidth+KPaddingHead2Message+KMessage_PaddingSmall+KMessage_PaddingBig+KPaddingRL);
    UIFont *tfont = [UIFont systemFontOfSize:18.0f];
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:tfont,NSFontAttributeName,nil];
    //
    //NSAttributedString *attrStr = [[NSAttributedString alloc] initWithString:self.message.text];
    //self.message.attributedText = attrStr;
    //NSRange range = NSMakeRange(0, attrStr.length);
    //NSDictionary *dic = [attrStr attributesAtIndex:0 effectiveRange:&range];
    CGRect rcMessage = [message boundingRectWithSize:CGSizeMake(messageAvailableWidth, 0) options:NSStringDrawingUsesLineFragmentOrigin|NSStringDrawingUsesFontLeading attributes:dic context:nil];
    return rcMessage.size;
}

- (CGSize)getCellSize:(NSString *)message {
    CGSize szCell = [self getMessageSize:message];
    szCell.width += (KMessage_PaddingSmall+KMessage_PaddingBig);
    szCell.height += (KMessage_PaddingTop+KMessage_PaddingBottom+KCell_Span);
    CGFloat headHeight = kHeadWidth+KPaddingTop+KPaddingTop;
    if (szCell.height <headHeight) {
        szCell.height = headHeight;
    }
    return szCell;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
}

@end
