//
//  LandscapeRoomViewController.m
//  nice2meet
//
//  Created by skin on 16/3/18.
//  Copyright © 2016年 Netease. All rights reserved.
//

#import "LandscapeRoomViewController.h"

@interface LandscapeRoomViewController ()
@property (assign, nonatomic) UIDeviceOrientation oldorientation;


@end


@implementation LandscapeRoomViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.videos_ui setBackground:@"bg_landscape"];
    self.toolbar.landscape = YES;
    self.oldorientation = [UIDevice currentDevice].orientation;
    [self setDeviceOrientation:UIDeviceOrientationLandscapeRight];
    [UIApplication sharedApplication].idleTimerDisabled = YES;
}

- (void)setDeviceOrientation:(UIDeviceOrientation)orientation {
    NSLog(@"setDeviceOrientation, orientation: old %lu, new %lu", (unsigned long)[UIDevice currentDevice].orientation, (unsigned long)orientation);
    if ([[UIDevice currentDevice] respondsToSelector:@selector(setOrientation:)]) {
        [[UIDevice currentDevice] performSelector:@selector(setOrientation:)
                                       withObject:[NSNumber numberWithInteger:orientation]];
    }
}

- (void)leaveRoom {
    [self setDeviceOrientation:self.oldorientation];
    [super leaveRoom];
}

#pragma mark -- Landscape
- (NSUInteger)supportedInterfaceOrientations {
    return UIInterfaceOrientationMaskLandscape;
}
- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation {
    return UIInterfaceOrientationLandscapeRight;
}
-(BOOL)shouldAutorotate {
    return NO;
}
//
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft ||
            interfaceOrientation == UIInterfaceOrientationLandscapeRight );
}

@end
