//
//  SettingViewController.m
//  nice2meet
//
//  Created by skin on 16/3/18.
//  Copyright © 2016年 Netease. All rights reserved.
//

#import "SettingViewController.h"
#import "N2MSetting.h"
#import "avd_sdk/AVDEngine.h"
#import "AppDelegate.h"

@interface SettingViewController ()<UITextFieldDelegate>
@property (weak, nonatomic) IBOutlet UITextField *serverUrl_ui;
@property (weak, nonatomic) IBOutlet UISegmentedControl *uiStyle_ui;
@property (weak, nonatomic) IBOutlet UISegmentedControl *videoCodec_ui;
@property (weak, nonatomic) IBOutlet UISegmentedControl *videoShow_ui;
@property (weak, nonatomic) IBOutlet UISegmentedControl *videoResolution_ui;
@property (weak, nonatomic) IBOutlet UISegmentedControl *datachannelNet_ui;
@property (weak, nonatomic) IBOutlet UISwitch *autoAudio_ui;
@property (weak, nonatomic) IBOutlet UISwitch *autoVideo_ui;

@end

@implementation SettingViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
     self.serverUrl_ui.delegate = self;
    [self.serverUrl_ui setText:[N2MSetting getServerURL]];
   
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    self.uiStyle_ui.selectedSegmentIndex = [userDefaults integerForKey:Key_uiStyle];
    self.videoShow_ui.selectedSegmentIndex = [userDefaults integerForKey:Key_videoShow];
    self.videoCodec_ui.selectedSegmentIndex = [userDefaults integerForKey:Key_videoCodec];
    self.videoResolution_ui.selectedSegmentIndex = [userDefaults integerForKey:Key_videoResolution];
    self.datachannelNet_ui.selectedSegmentIndex  = [userDefaults integerForKey:Key_datachannelNet];
    self.autoAudio_ui.on = [userDefaults boolForKey:Key_autoAudioOpen];
    self.autoVideo_ui.on = [userDefaults boolForKey:Key_autoVideoOpen];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

- (IBAction)btnSettingApply:(id)sender {
    BOOL isNeedReinitEngine = NO;
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    NSString *oldserverUrl = [userDefaults stringForKey:Key_serverUrl];
    if (![self.serverUrl_ui.text isEqualToString:oldserverUrl]) {
        [userDefaults setObject:self.serverUrl_ui.text forKey:Key_serverUrl];
        isNeedReinitEngine = YES;
    }
    if ([userDefaults integerForKey:Key_videoCodec] != self.videoCodec_ui.selectedSegmentIndex) {
        [userDefaults setInteger:self.videoCodec_ui.selectedSegmentIndex forKey:Key_videoCodec];
        if (!isNeedReinitEngine) {
            [[AVDEngine instance] setOption:video_codec_priority value:[N2MSetting getVideoCodecOption]];
        }
    }
    if ([userDefaults integerForKey:Key_videoResolution] != self.videoResolution_ui.selectedSegmentIndex) {
        [userDefaults setInteger:self.videoResolution_ui.selectedSegmentIndex forKey:Key_videoResolution];
        if (!isNeedReinitEngine) {
            [[AVDEngine instance] setOption:camera_capability_default value:[N2MSetting getVideoResolutionOption]];
        }
    }
    if ([userDefaults integerForKey:Key_datachannelNet] != self.datachannelNet_ui.selectedSegmentIndex) {
        [userDefaults setInteger:self.datachannelNet_ui.selectedSegmentIndex forKey:Key_datachannelNet];
        if (!isNeedReinitEngine) {
            [[AVDEngine instance] setOption:data_channel_tcp_priority value:[N2MSetting getDataChannelNetOption]];
        }
    }
    [userDefaults setInteger:self.uiStyle_ui.selectedSegmentIndex forKey:Key_uiStyle];
    [userDefaults setInteger:self.videoShow_ui.selectedSegmentIndex forKey:Key_videoShow];
    [userDefaults setBool:self.autoAudio_ui.on forKey:Key_autoAudioOpen];
    [userDefaults setBool:self.autoVideo_ui.on forKey:Key_autoVideoOpen];
    
    if (isNeedReinitEngine) {
        AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
        if (nil != appDelegate) {
            [appDelegate reInitEngine];
        }
    }
    [self dismissViewControllerAnimated:YES completion:^{}];
}

@end
