//
//  VideoViewCell.h
//  nice2meet
//
//  Created by Netease on 15/8/18.
//  Copyright (c) 2015年 Netease. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <UIKit/UILabel.h>
#import <avd_sdk/AVDCommon.h>
#import <avd_sdk/AVDVideoView.h>

@protocol VideoViewCellDelegate <NSObject>
- (void)onSwitchLocalCamera:(AVDDeviceId)deviceId;
- (BOOL)onRecordVideo:(AVDDeviceId)deviceId;
- (BOOL)onLivebcVideo:(AVDDeviceId)deviceId;
- (void)onLiveShare:(AVDLiveId)liveId;

@end

@interface VideoViewCell : AVDVideoView
@property (nonatomic,weak) id <VideoViewCellDelegate> delegate;
@property (nonatomic, weak, readonly) AVDDeviceId deviceId;
@property (nonatomic, strong) AVDRecordId recordId;
@property (nonatomic, strong) AVDLiveId liveId;

- (BOOL)hasVideo;
- (BOOL)issVideo:(AVDDeviceId)deviceId;
- (void)setVideo:(AVDDeviceId)deviceId title:(NSString*)title isSwitch:(BOOL)isswitch isRecord:(BOOL)isRecord isLive:(BOOL)isLive;
- (void)setBackground:(NSString*)imagename;

@end
